// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package askgrpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion7

// AskClient is the client API for Ask service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type AskClient interface {
	Create(ctx context.Context, in *CreateQuestion, opts ...grpc.CallOption) (*AskIDWrapper, error)
	Get(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*GetQuestion, error)
	GetMeta(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*QuestionMeta, error)
	Delete(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*AskEmpty, error)
}

type askClient struct {
	cc grpc.ClientConnInterface
}

func NewAskClient(cc grpc.ClientConnInterface) AskClient {
	return &askClient{cc}
}

func (c *askClient) Create(ctx context.Context, in *CreateQuestion, opts ...grpc.CallOption) (*AskIDWrapper, error) {
	out := new(AskIDWrapper)
	err := c.cc.Invoke(ctx, "/Ask/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *askClient) Get(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*GetQuestion, error) {
	out := new(GetQuestion)
	err := c.cc.Invoke(ctx, "/Ask/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *askClient) GetMeta(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*QuestionMeta, error) {
	out := new(QuestionMeta)
	err := c.cc.Invoke(ctx, "/Ask/GetMeta", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *askClient) Delete(ctx context.Context, in *AskIDWrapper, opts ...grpc.CallOption) (*AskEmpty, error) {
	out := new(AskEmpty)
	err := c.cc.Invoke(ctx, "/Ask/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AskServer is the server API for Ask service.
// All implementations must embed UnimplementedAskServer
// for forward compatibility
type AskServer interface {
	Create(context.Context, *CreateQuestion) (*AskIDWrapper, error)
	Get(context.Context, *AskIDWrapper) (*GetQuestion, error)
	GetMeta(context.Context, *AskIDWrapper) (*QuestionMeta, error)
	Delete(context.Context, *AskIDWrapper) (*AskEmpty, error)
	mustEmbedUnimplementedAskServer()
}

// UnimplementedAskServer must be embedded to have forward compatible implementations.
type UnimplementedAskServer struct {
}

func (UnimplementedAskServer) Create(context.Context, *CreateQuestion) (*AskIDWrapper, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedAskServer) Get(context.Context, *AskIDWrapper) (*GetQuestion, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedAskServer) GetMeta(context.Context, *AskIDWrapper) (*QuestionMeta, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetMeta not implemented")
}
func (UnimplementedAskServer) Delete(context.Context, *AskIDWrapper) (*AskEmpty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedAskServer) mustEmbedUnimplementedAskServer() {}

// UnsafeAskServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AskServer will
// result in compilation errors.
type UnsafeAskServer interface {
	mustEmbedUnimplementedAskServer()
}

func RegisterAskServer(s *grpc.Server, srv AskServer) {
	s.RegisterService(&_Ask_serviceDesc, srv)
}

func _Ask_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateQuestion)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AskServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Ask/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AskServer).Create(ctx, req.(*CreateQuestion))
	}
	return interceptor(ctx, in, info, handler)
}

func _Ask_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AskIDWrapper)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AskServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Ask/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AskServer).Get(ctx, req.(*AskIDWrapper))
	}
	return interceptor(ctx, in, info, handler)
}

func _Ask_GetMeta_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AskIDWrapper)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AskServer).GetMeta(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Ask/GetMeta",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AskServer).GetMeta(ctx, req.(*AskIDWrapper))
	}
	return interceptor(ctx, in, info, handler)
}

func _Ask_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AskIDWrapper)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AskServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Ask/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AskServer).Delete(ctx, req.(*AskIDWrapper))
	}
	return interceptor(ctx, in, info, handler)
}

var _Ask_serviceDesc = grpc.ServiceDesc{
	ServiceName: "Ask",
	HandlerType: (*AskServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Ask_Create_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Ask_Get_Handler,
		},
		{
			MethodName: "GetMeta",
			Handler:    _Ask_GetMeta_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Ask_Delete_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "ask.proto",
}
